Index: lemon/concepts/graph_components.h
===================================================================
--- lemon/concepts/graph_components.h	(revision 584)
+++ lemon/concepts/graph_components.h	(revision 534)
@@ -1374,15 +1360,15 @@
     };
 
-    /// \brief Skeleton class for erasable directed graphs.
-    ///
-    /// This class describes the interface of erasable directed graphs.
-    /// It extends \ref BaseDigraphComponent with functions for removing 
-    /// nodes and arcs from the digraph.
-    /// This concept requires \ref AlterableDigraphComponent.
-    template <typename BAS = BaseDigraphComponent>
-    class ErasableDigraphComponent : public BAS {
-    public:
-
-      typedef BAS Base;
+    /// \brief An empty erasable digraph class.
+    ///
+    /// This class provides beside the core digraph features core erase
+    /// functions for the digraph structure. The main difference between
+    /// the base and this interface is that the digraph alterations
+    /// should handled already on this level.
+    template <typename _Base = BaseDigraphComponent>
+    class ErasableDigraphComponent : public _Base {
+    public:
+
+      typedef _Base Base;
       typedef typename Base::Node Node;
       typedef typename Base::Arc Arc;
@@ -1390,11 +1376,12 @@
       /// \brief Erase a node from the digraph.
       ///
-      /// This function erases the given node from the digraph and all arcs 
-      /// connected to the node.
+      /// Erase a node from the digraph. This function should
+      /// erase all arcs connecting to the node.
       void erase(const Node&) {}
 
       /// \brief Erase an arc from the digraph.
       ///
-      /// This function erases the given arc from the digraph.
+      /// Erase an arc from the digraph.
+      ///
       void erase(const Arc&) {}
 
@@ -1403,7 +1390,7 @@
         void constraints() {
           checkConcept<Base, _Digraph>();
-          const typename _Digraph::Node node(INVALID);
+          typename _Digraph::Node node;
           digraph.erase(node);
-          const typename _Digraph::Arc arc(INVALID);
+          typename _Digraph::Arc arc;
           digraph.erase(arc);
         }
@@ -1413,15 +1400,15 @@
     };
 
-    /// \brief Skeleton class for erasable undirected graphs.
-    ///
-    /// This class describes the interface of erasable undirected graphs.
-    /// It extends \ref BaseGraphComponent with functions for removing 
-    /// nodes and edges from the graph.
-    /// This concept requires \ref AlterableGraphComponent.
-    template <typename BAS = BaseGraphComponent>
-    class ErasableGraphComponent : public BAS {
-    public:
-
-      typedef BAS Base;
+    /// \brief An empty erasable base undirected graph class.
+    ///
+    /// This class provides beside the core undirected graph features
+    /// core erase functions for the undirceted graph structure. The
+    /// main difference between the base and this interface is that
+    /// the graph alterations should handled already on this level.
+    template <typename _Base = BaseGraphComponent>
+    class ErasableGraphComponent : public _Base {
+    public:
+
+      typedef _Base Base;
       typedef typename Base::Node Node;
       typedef typename Base::Edge Edge;
@@ -1429,11 +1416,12 @@
       /// \brief Erase a node from the graph.
       ///
-      /// This function erases the given node from the graph and all edges
-      /// connected to the node.
+      /// Erase a node from the graph. This function should erase
+      /// arcs connecting to the node.
       void erase(const Node&) {}
 
-      /// \brief Erase an edge from the digraph.
-      ///
-      /// This function erases the given edge from the digraph.
+      /// \brief Erase an arc from the graph.
+      ///
+      /// Erase an arc from the graph.
+      ///
       void erase(const Edge&) {}
 
@@ -1442,7 +1430,7 @@
         void constraints() {
           checkConcept<Base, _Graph>();
-          const typename _Graph::Node node(INVALID);
+          typename _Graph::Node node;
           graph.erase(node);
-          const typename _Graph::Edge edge(INVALID);
+          typename _Graph::Edge edge;
           graph.erase(edge);
         }
@@ -1452,19 +1440,20 @@
     };
 
-    /// \brief Skeleton class for clearable directed graphs.
-    ///
-    /// This class describes the interface of clearable directed graphs.
-    /// It extends \ref BaseDigraphComponent with a function for clearing
-    /// the digraph.
-    /// This concept requires \ref AlterableDigraphComponent.
-    template <typename BAS = BaseDigraphComponent>
-    class ClearableDigraphComponent : public BAS {
-    public:
-
-      typedef BAS Base;
+    /// \brief An empty clearable base digraph class.
+    ///
+    /// This class provides beside the core digraph features core clear
+    /// functions for the digraph structure. The main difference between
+    /// the base and this interface is that the digraph alterations
+    /// should handled already on this level.
+    template <typename _Base = BaseDigraphComponent>
+    class ClearableDigraphComponent : public _Base {
+    public:
+
+      typedef _Base Base;
 
       /// \brief Erase all nodes and arcs from the digraph.
       ///
-      /// This function erases all nodes and arcs from the digraph.
+      /// Erase all nodes and arcs from the digraph.
+      ///
       void clear() {}
 
@@ -1476,33 +1465,27 @@
         }
 
-        _Digraph& digraph;
-      };
-    };
-
-    /// \brief Skeleton class for clearable undirected graphs.
-    ///
-    /// This class describes the interface of clearable undirected graphs.
-    /// It extends \ref BaseGraphComponent with a function for clearing
-    /// the graph.
-    /// This concept requires \ref AlterableGraphComponent.
-    template <typename BAS = BaseGraphComponent>
-    class ClearableGraphComponent : public ClearableDigraphComponent<BAS> {
-    public:
-
-      typedef BAS Base;
-
-      /// \brief Erase all nodes and edges from the graph.
-      ///
-      /// This function erases all nodes and edges from the graph.
-      void clear() {}
+        _Digraph digraph;
+      };
+    };
+
+    /// \brief An empty clearable base undirected graph class.
+    ///
+    /// This class provides beside the core undirected graph features
+    /// core clear functions for the undirected graph structure. The
+    /// main difference between the base and this interface is that
+    /// the graph alterations should handled already on this level.
+    template <typename _Base = BaseGraphComponent>
+    class ClearableGraphComponent : public ClearableDigraphComponent<_Base> {
+    public:
+
+      typedef _Base Base;
 
       template <typename _Graph>
       struct Constraints {
         void constraints() {
-          checkConcept<Base, _Graph>();
-          graph.clear();
-        }
-
-        _Graph& graph;
+          checkConcept<ClearableGraphComponent<Base>, _Graph>();
+        }
+
+        _Graph graph;
       };
     };
Index: lemon/concepts/heap.h
===================================================================
--- lemon/concepts/heap.h	(revision 584)
+++ lemon/concepts/heap.h	(revision 529)
@@ -36,29 +36,14 @@
     /// \brief The heap concept.
     ///
-    /// Concept class describing the main interface of heaps. A \e heap
-    /// is a data structure for storing items with specified values called
-    /// \e priorities in such a way that finding the item with minimum
-    /// priority is efficient. In a heap one can change the priority of an
-    /// item, add or erase an item, etc.
-    ///
-    /// \tparam PR Type of the priority of the items.
-    /// \tparam IM A read and writable item map with int values, used
-    /// internally to handle the cross references.
-    /// \tparam Comp A functor class for the ordering of the priorities.
-    /// The default is \c std::less<PR>.
-#ifdef DOXYGEN
-    template <typename PR, typename IM, typename Comp = std::less<PR> >
-#else
-    template <typename PR, typename IM>
-#endif
+    /// Concept class describing the main interface of heaps.
+    template <typename Priority, typename ItemIntMap>
     class Heap {
     public:
 
-      /// Type of the item-int map.
-      typedef IM ItemIntMap;
-      /// Type of the priorities.
-      typedef PR Prio;
       /// Type of the items stored in the heap.
       typedef typename ItemIntMap::Key Item;
+
+      /// Type of the priorities.
+      typedef Priority Prio;
 
       /// \brief Type to represent the states of the items.
@@ -69,10 +54,10 @@
       /// the user.
       ///
-      /// The item-int map must be initialized in such way that it assigns
-      /// \c PRE_HEAP (<tt>-1</tt>) to any element to be put in the heap.
+      /// The \c ItemIntMap must be initialized in such a way, that it
+      /// assigns \c PRE_HEAP (<tt>-1</tt>) to every item.
       enum State {
-        IN_HEAP = 0,    ///< = 0. The "in heap" state constant.
-        PRE_HEAP = -1,  ///< = -1. The "pre heap" state constant.
-        POST_HEAP = -2  ///< = -2. The "post heap" state constant.
+        IN_HEAP = 0,
+        PRE_HEAP = -1,
+        POST_HEAP = -2
       };
 
@@ -135,6 +120,6 @@
       ///
       /// Returns the priority of the given item.
-      /// \param i The item.
       /// \pre \c i must be in the heap.
+      /// \param i The item.
       Prio operator[](const Item &i) const {}
 
@@ -153,7 +138,7 @@
       ///
       /// Decreases the priority of an item to the given value.
+      /// \pre \c i must be stored in the heap with priority at least \c p.
       /// \param i The item.
       /// \param p The priority.
-      /// \pre \c i must be stored in the heap with priority at least \c p.
       void decrease(const Item &i, const Prio &p) {}
 
@@ -161,7 +146,7 @@
       ///
       /// Increases the priority of an item to the given value.
+      /// \pre \c i must be stored in the heap with priority at most \c p.
       /// \param i The item.
       /// \param p The priority.
-      /// \pre \c i must be stored in the heap with priority at most \c p.
       void increase(const Item &i, const Prio &p) {}
 
Index: lemon/concepts/path.h
===================================================================
--- lemon/concepts/path.h	(revision 559)
+++ lemon/concepts/path.h	(revision 529)
@@ -39,5 +39,5 @@
     /// A skeleton structure for representing directed paths in a
     /// digraph.
-    /// \tparam GR The digraph type in which the path is.
+    /// \tparam _Digraph The digraph type in which the path is.
     ///
     /// In a sense, the path can be treated as a list of arcs. The
@@ -46,10 +46,10 @@
     /// paths cannot store the source.
     ///
-    template <typename GR>
+    template <typename _Digraph>
     class Path {
     public:
 
       /// Type of the underlying digraph.
-      typedef GR Digraph;
+      typedef _Digraph Digraph;
       /// Arc type of the underlying digraph.
       typedef typename Digraph::Arc Arc;
@@ -206,15 +206,16 @@
     /// assigned to a real path and the dumpers can be implemented as
     /// an adaptor class to the predecessor map.
-    ///
-    /// \tparam GR The digraph type in which the path is.
+
+    /// \tparam _Digraph  The digraph type in which the path is.
     ///
     /// The paths can be constructed from any path type by a
     /// template constructor or a template assignment operator.
-    template <typename GR>
+    ///
+    template <typename _Digraph>
     class PathDumper {
     public:
 
       /// Type of the underlying digraph.
-      typedef GR Digraph;
+      typedef _Digraph Digraph;
       /// Arc type of the underlying digraph.
       typedef typename Digraph::Arc Arc;
Index: lemon/config.h.in
===================================================================
--- lemon/config.h.in	(revision 567)
+++ lemon/config.h.in	(revision 517)
@@ -19,5 +19,2 @@
 /* Define to 1 if you have CLP */
 #undef HAVE_CLP
-
-/* Define to 1 if you have CBC */
-#undef HAVE_CBC
Index: lemon/connectivity.h
===================================================================
--- lemon/connectivity.h	(revision 586)
+++ lemon/connectivity.h	(revision 440)
@@ -33,5 +33,5 @@
 #include <functional>
 
-/// \ingroup graph_properties
+/// \ingroup connectivity
 /// \file
 /// \brief Connectivity algorithms
@@ -41,5 +41,5 @@
 namespace lemon {
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Check whether the given undirected graph is connected.
@@ -47,5 +47,5 @@
   /// Check whether the given undirected graph is connected.
   /// \param graph The undirected graph.
-  /// \return \c true when there is path between any two nodes in the graph.
+  /// \return %True when there is path between any two nodes in the graph.
   /// \note By definition, the empty graph is connected.
   template <typename Graph>
@@ -64,5 +64,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Count the number of connected components of an undirected graph
@@ -106,12 +106,9 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Find the connected components of an undirected graph
   ///
   /// Find the connected components of an undirected graph.
-  ///
-  /// \image html connected_components.png
-  /// \image latex connected_components.eps "Connected components" width=\textwidth
   ///
   /// \param graph The graph. It must be undirected.
@@ -121,4 +118,5 @@
   /// set continuously.
   /// \return The number of components
+  ///
   template <class Graph, class NodeMap>
   int connectedComponents(const Graph &graph, NodeMap &compMap) {
@@ -230,5 +228,5 @@
 
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Check whether the given directed graph is strongly connected.
@@ -237,5 +235,5 @@
   /// graph is strongly connected when any two nodes of the graph are
   /// connected with directed paths in both direction.
-  /// \return \c false when the graph is not strongly connected.
+  /// \return %False when the graph is not strongly connected.
   /// \see connected
   ///
@@ -288,5 +286,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Count the strongly connected components of a directed graph
@@ -352,5 +350,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Find the strongly connected components of a directed graph
@@ -364,7 +362,4 @@
   /// a lower.
   ///
-  /// \image html strongly_connected_components.png
-  /// \image latex strongly_connected_components.eps "Strongly connected components" width=\textwidth
-  ///
   /// \param digraph The digraph.
   /// \retval compMap A writable node map. The values will be set from 0 to
@@ -373,4 +368,5 @@
   /// will be set continuously.
   /// \return The number of components
+  ///
   template <typename Digraph, typename NodeMap>
   int stronglyConnectedComponents(const Digraph& digraph, NodeMap& compMap) {
@@ -421,5 +417,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Find the cut arcs of the strongly connected components.
@@ -705,5 +701,5 @@
   int countBiNodeConnectedComponents(const Graph& graph);
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Checks the graph is bi-node-connected.
@@ -714,5 +710,5 @@
   ///
   /// \param graph The graph.
-  /// \return \c true when the graph bi-node-connected.
+  /// \return %True when the graph bi-node-connected.
   template <typename Graph>
   bool biNodeConnected(const Graph& graph) {
@@ -720,5 +716,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Count the biconnected components.
@@ -755,5 +751,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Find the bi-node-connected components.
@@ -763,7 +759,4 @@
   /// relation on the undirected edges. Two undirected edge are in relationship
   /// when they are on same circle.
-  ///
-  /// \image html node_biconnected_components.png
-  /// \image latex node_biconnected_components.eps "bi-node-connected components" width=\textwidth
   ///
   /// \param graph The graph.
@@ -773,4 +766,5 @@
   /// will be set continuously.
   /// \return The number of components.
+  ///
   template <typename Graph, typename EdgeMap>
   int biNodeConnectedComponents(const Graph& graph,
@@ -800,5 +794,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Find the bi-node-connected cut nodes.
@@ -1030,5 +1024,5 @@
   int countBiEdgeConnectedComponents(const Graph& graph);
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Checks that the graph is bi-edge-connected.
@@ -1045,5 +1039,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Count the bi-edge-connected components.
@@ -1080,5 +1074,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Find the bi-edge-connected components.
@@ -1088,7 +1082,4 @@
   /// relation on the nodes. Two nodes are in relationship when they are
   /// connected at least two edge-disjoint paths.
-  ///
-  /// \image html edge_biconnected_components.png
-  /// \image latex edge_biconnected_components.eps "bi-edge-connected components" width=\textwidth
   ///
   /// \param graph The graph.
@@ -1098,4 +1089,5 @@
   /// will be set continuously.
   /// \return The number of components.
+  ///
   template <typename Graph, typename NodeMap>
   int biEdgeConnectedComponents(const Graph& graph, NodeMap& compMap) {
@@ -1124,5 +1116,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Find the bi-edge-connected cut edges.
@@ -1188,5 +1180,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Sort the nodes of a DAG into topolgical order.
@@ -1227,5 +1219,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Sort the nodes of a DAG into topolgical order.
@@ -1239,5 +1231,5 @@
   /// of the map will be set exactly once, the values will be set descending
   /// order.
-  /// \return \c false when the graph is not DAG.
+  /// \return %False when the graph is not DAG.
   ///
   /// \see topologicalSort
@@ -1282,5 +1274,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Check that the given directed graph is a DAG.
@@ -1288,5 +1280,5 @@
   /// Check that the given directed graph is a DAG. The DAG is
   /// an Directed Acyclic Digraph.
-  /// \return \c false when the graph is not DAG.
+  /// \return %False when the graph is not DAG.
   /// \see acyclic
   template <typename Digraph>
@@ -1324,5 +1316,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Check that the given undirected graph is acyclic.
@@ -1330,5 +1322,5 @@
   /// Check that the given undirected graph acyclic.
   /// \param graph The undirected graph.
-  /// \return \c true when there is no circle in the graph.
+  /// \return %True when there is no circle in the graph.
   /// \see dag
   template <typename Graph>
@@ -1358,5 +1350,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Check that the given undirected graph is tree.
@@ -1364,5 +1356,5 @@
   /// Check that the given undirected graph is tree.
   /// \param graph The undirected graph.
-  /// \return \c true when the graph is acyclic and connected.
+  /// \return %True when the graph is acyclic and connected.
   template <typename Graph>
   bool tree(const Graph& graph) {
@@ -1450,5 +1442,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Check if the given undirected graph is bipartite or not
@@ -1457,5 +1449,5 @@
   /// or not. The \ref Bfs algorithm is used to calculate the result.
   /// \param graph The undirected graph.
-  /// \return \c true if \c graph is bipartite, \c false otherwise.
+  /// \return %True if \c graph is bipartite, %false otherwise.
   /// \sa bipartitePartitions
   template<typename Graph>
@@ -1487,5 +1479,5 @@
   }
 
-  /// \ingroup graph_properties
+  /// \ingroup connectivity
   ///
   /// \brief Check if the given undirected graph is bipartite or not
@@ -1495,12 +1487,8 @@
   /// During the execution, the \c partMap will be set as the two
   /// partitions of the graph.
-  ///
-  /// \image html bipartite_partitions.png
-  /// \image latex bipartite_partitions.eps "Bipartite partititions" width=\textwidth
-  ///
   /// \param graph The undirected graph.
   /// \retval partMap A writable bool map of nodes. It will be set as the
   /// two partitions of the graph.
-  /// \return \c true if \c graph is bipartite, \c false otherwise.
+  /// \return %True if \c graph is bipartite, %false otherwise.
   template<typename Graph, typename NodeMap>
   inline bool bipartitePartitions(const Graph &graph, NodeMap &partMap){
Index: lemon/core.h
===================================================================
--- lemon/core.h	(revision 581)
+++ lemon/core.h	(revision 535)
@@ -1035,9 +1035,9 @@
   ///\sa findArc()
   ///\sa ArcLookUp, AllArcLookUp, DynArcLookUp
-  template <typename GR>
-  class ConArcIt : public GR::Arc {
+  template <typename _Graph>
+  class ConArcIt : public _Graph::Arc {
   public:
 
-    typedef GR Graph;
+    typedef _Graph Graph;
     typedef typename Graph::Arc Parent;
 
@@ -1158,9 +1158,9 @@
   ///
   ///\sa findEdge()
-  template <typename GR>
-  class ConEdgeIt : public GR::Edge {
+  template <typename _Graph>
+  class ConEdgeIt : public _Graph::Edge {
   public:
 
-    typedef GR Graph;
+    typedef _Graph Graph;
     typedef typename Graph::Edge Parent;
 
@@ -1212,27 +1212,27 @@
   ///queries.
   ///
-  ///\tparam GR The type of the underlying digraph.
+  ///\tparam G The type of the underlying digraph.
   ///
   ///\sa ArcLookUp
   ///\sa AllArcLookUp
-  template <typename GR>
+  template<class G>
   class DynArcLookUp
-    : protected ItemSetTraits<GR, typename GR::Arc>::ItemNotifier::ObserverBase
+    : protected ItemSetTraits<G, typename G::Arc>::ItemNotifier::ObserverBase
   {
   public:
-    typedef typename ItemSetTraits<GR, typename GR::Arc>
+    typedef typename ItemSetTraits<G, typename G::Arc>
     ::ItemNotifier::ObserverBase Parent;
 
-    TEMPLATE_DIGRAPH_TYPEDEFS(GR);
-    typedef GR Digraph;
+    TEMPLATE_DIGRAPH_TYPEDEFS(G);
+    typedef G Digraph;
 
   protected:
 
-    class AutoNodeMap : public ItemSetTraits<GR, Node>::template Map<Arc>::Type {
+    class AutoNodeMap : public ItemSetTraits<G, Node>::template Map<Arc>::Type {
     public:
 
-      typedef typename ItemSetTraits<GR, Node>::template Map<Arc>::Type Parent;
-
-      AutoNodeMap(const GR& digraph) : Parent(digraph, INVALID) {}
+      typedef typename ItemSetTraits<G, Node>::template Map<Arc>::Type Parent;
+
+      AutoNodeMap(const G& digraph) : Parent(digraph, INVALID) {}
 
       virtual void add(const Node& node) {
@@ -1316,5 +1316,5 @@
     virtual void clear() {
       for(NodeIt n(_g);n!=INVALID;++n) {
-        _head[n] = INVALID;
+        _head.set(n, INVALID);
       }
     }
@@ -1323,11 +1323,11 @@
       Node s = _g.source(arc);
       Node t = _g.target(arc);
-      _left[arc] = INVALID;
-      _right[arc] = INVALID;
+      _left.set(arc, INVALID);
+      _right.set(arc, INVALID);
 
       Arc e = _head[s];
       if (e == INVALID) {
-        _head[s] = arc;
-        _parent[arc] = INVALID;
+        _head.set(s, arc);
+        _parent.set(arc, INVALID);
         return;
       }
@@ -1335,6 +1335,6 @@
         if (t < _g.target(e)) {
           if (_left[e] == INVALID) {
-            _left[e] = arc;
-            _parent[arc] = e;
+            _left.set(e, arc);
+            _parent.set(arc, e);
             splay(arc);
             return;
@@ -1344,6 +1344,6 @@
         } else {
           if (_right[e] == INVALID) {
-            _right[e] = arc;
-            _parent[arc] = e;
+            _right.set(e, arc);
+            _parent.set(arc, e);
             splay(arc);
             return;
@@ -1358,25 +1358,25 @@
       if (_left[arc] == INVALID) {
         if (_right[arc] != INVALID) {
-          _parent[_right[arc]] = _parent[arc];
+          _parent.set(_right[arc], _parent[arc]);
         }
         if (_parent[arc] != INVALID) {
           if (_left[_parent[arc]] == arc) {
-            _left[_parent[arc]] = _right[arc];
+            _left.set(_parent[arc], _right[arc]);
           } else {
-            _right[_parent[arc]] = _right[arc];
+            _right.set(_parent[arc], _right[arc]);
           }
         } else {
-          _head[_g.source(arc)] = _right[arc];
+          _head.set(_g.source(arc), _right[arc]);
         }
       } else if (_right[arc] == INVALID) {
-        _parent[_left[arc]] = _parent[arc];
+        _parent.set(_left[arc], _parent[arc]);
         if (_parent[arc] != INVALID) {
           if (_left[_parent[arc]] == arc) {
-            _left[_parent[arc]] = _left[arc];
+            _left.set(_parent[arc], _left[arc]);
           } else {
-            _right[_parent[arc]] = _left[arc];
+            _right.set(_parent[arc], _left[arc]);
           }
         } else {
-          _head[_g.source(arc)] = _left[arc];
+          _head.set(_g.source(arc), _left[arc]);
         }
       } else {
@@ -1388,36 +1388,36 @@
           }
           Arc s = _parent[e];
-          _right[_parent[e]] = _left[e];
+          _right.set(_parent[e], _left[e]);
           if (_left[e] != INVALID) {
-            _parent[_left[e]] = _parent[e];
+            _parent.set(_left[e], _parent[e]);
           }
 
-          _left[e] = _left[arc];
-          _parent[_left[arc]] = e;
-          _right[e] = _right[arc];
-          _parent[_right[arc]] = e;
-
-          _parent[e] = _parent[arc];
+          _left.set(e, _left[arc]);
+          _parent.set(_left[arc], e);
+          _right.set(e, _right[arc]);
+          _parent.set(_right[arc], e);
+
+          _parent.set(e, _parent[arc]);
           if (_parent[arc] != INVALID) {
             if (_left[_parent[arc]] == arc) {
-              _left[_parent[arc]] = e;
+              _left.set(_parent[arc], e);
             } else {
-              _right[_parent[arc]] = e;
+              _right.set(_parent[arc], e);
             }
           }
           splay(s);
         } else {
-          _right[e] = _right[arc];
-          _parent[_right[arc]] = e;
-          _parent[e] = _parent[arc];
+          _right.set(e, _right[arc]);
+          _parent.set(_right[arc], e);
+          _parent.set(e, _parent[arc]);
 
           if (_parent[arc] != INVALID) {
             if (_left[_parent[arc]] == arc) {
-              _left[_parent[arc]] = e;
+              _left.set(_parent[arc], e);
             } else {
-              _right[_parent[arc]] = e;
+              _right.set(_parent[arc], e);
             }
           } else {
-            _head[_g.source(arc)] = e;
+            _head.set(_g.source(arc), e);
           }
         }
@@ -1431,15 +1431,15 @@
       if (a < m) {
         Arc left = refreshRec(v,a,m-1);
-        _left[me] = left;
-        _parent[left] = me;
+        _left.set(me, left);
+        _parent.set(left, me);
       } else {
-        _left[me] = INVALID;
+        _left.set(me, INVALID);
       }
       if (m < b) {
         Arc right = refreshRec(v,m+1,b);
-        _right[me] = right;
-        _parent[right] = me;
+        _right.set(me, right);
+        _parent.set(right, me);
       } else {
-        _right[me] = INVALID;
+        _right.set(me, INVALID);
       }
       return me;
@@ -1453,8 +1453,8 @@
           std::sort(v.begin(),v.end(),ArcLess(_g));
           Arc head = refreshRec(v,0,v.size()-1);
-          _head[n] = head;
-          _parent[head] = INVALID;
-        }
-        else _head[n] = INVALID;
+          _head.set(n, head);
+          _parent.set(head, INVALID);
+        }
+        else _head.set(n, INVALID);
       }
     }
@@ -1462,17 +1462,17 @@
     void zig(Arc v) {
       Arc w = _parent[v];
-      _parent[v] = _parent[w];
-      _parent[w] = v;
-      _left[w] = _right[v];
-      _right[v] = w;
+      _parent.set(v, _parent[w]);
+      _parent.set(w, v);
+      _left.set(w, _right[v]);
+      _right.set(v, w);
       if (_parent[v] != INVALID) {
         if (_right[_parent[v]] == w) {
-          _right[_parent[v]] = v;
+          _right.set(_parent[v], v);
         } else {
-          _left[_parent[v]] = v;
+          _left.set(_parent[v], v);
         }
       }
       if (_left[w] != INVALID){
-        _parent[_left[w]] = w;
+        _parent.set(_left[w], w);
       }
     }
@@ -1480,17 +1480,17 @@
     void zag(Arc v) {
       Arc w = _parent[v];
-      _parent[v] = _parent[w];
-      _parent[w] = v;
-      _right[w] = _left[v];
-      _left[v] = w;
+      _parent.set(v, _parent[w]);
+      _parent.set(w, v);
+      _right.set(w, _left[v]);
+      _left.set(v, w);
       if (_parent[v] != INVALID){
         if (_left[_parent[v]] == w) {
-          _left[_parent[v]] = v;
+          _left.set(_parent[v], v);
         } else {
-          _right[_parent[v]] = v;
+          _right.set(_parent[v], v);
         }
       }
       if (_right[w] != INVALID){
-        _parent[_right[w]] = w;
+        _parent.set(_right[w], w);
       }
     }
@@ -1624,14 +1624,14 @@
   ///(<em>O</em>(<em>m</em> log<em>m</em>)) to the number of arcs).
   ///
-  ///\tparam GR The type of the underlying digraph.
+  ///\tparam G The type of the underlying digraph.
   ///
   ///\sa DynArcLookUp
   ///\sa AllArcLookUp
-  template<class GR>
+  template<class G>
   class ArcLookUp
   {
   public:
-    TEMPLATE_DIGRAPH_TYPEDEFS(GR);
-    typedef GR Digraph;
+    TEMPLATE_DIGRAPH_TYPEDEFS(G);
+    typedef G Digraph;
 
   protected:
@@ -1734,18 +1734,18 @@
   ///(<em>O</em>(<em>m</em> log<em>m</em>)) to the number of arcs).
   ///
-  ///\tparam GR The type of the underlying digraph.
+  ///\tparam G The type of the underlying digraph.
   ///
   ///\sa DynArcLookUp
   ///\sa ArcLookUp
-  template<class GR>
-  class AllArcLookUp : public ArcLookUp<GR>
+  template<class G>
+  class AllArcLookUp : public ArcLookUp<G>
   {
-    using ArcLookUp<GR>::_g;
-    using ArcLookUp<GR>::_right;
-    using ArcLookUp<GR>::_left;
-    using ArcLookUp<GR>::_head;
-
-    TEMPLATE_DIGRAPH_TYPEDEFS(GR);
-    typedef GR Digraph;
+    using ArcLookUp<G>::_g;
+    using ArcLookUp<G>::_right;
+    using ArcLookUp<G>::_left;
+    using ArcLookUp<G>::_head;
+
+    TEMPLATE_DIGRAPH_TYPEDEFS(G);
+    typedef G Digraph;
 
     typename Digraph::template ArcMap<Arc> _next;
@@ -1774,5 +1774,5 @@
     ///It builds up the search database, which remains valid until the digraph
     ///changes.
-    AllArcLookUp(const Digraph &g) : ArcLookUp<GR>(g), _next(g) {refreshNext();}
+    AllArcLookUp(const Digraph &g) : ArcLookUp<G>(g), _next(g) {refreshNext();}
 
     ///Refresh the data structure at a node.
@@ -1784,5 +1784,5 @@
     void refresh(Node n)
     {
-      ArcLookUp<GR>::refresh(n);
+      ArcLookUp<G>::refresh(n);
       refreshNext(_head[n]);
     }
@@ -1831,5 +1831,5 @@
     Arc operator()(Node s, Node t, Arc prev=INVALID) const {}
 #else
-    using ArcLookUp<GR>::operator() ;
+    using ArcLookUp<G>::operator() ;
     Arc operator()(Node s, Node t, Arc prev) const
     {
